<?php

use QL\QueryList;

require __DIR__ . '/vendor/autoload.php';
require __DIR__ . '/network.php';
require __DIR__ . '/appcentre_function.php';

function main_handler($event, $context)
{
    $html = Server_SendRequest('https://app.zblogcn.com/zb_users/plugin/AppBuy/shop/main.php');

    print_r('Query AppCentre order data: '.$html."\n");

    $rules = [
        'pay_time' => ['td:nth-child(6)', 'text'],
        'app' => ['td:nth-child(4)', 'text'],
        'user' => ['td:nth-child(3)', 'text'],
        'income' => ['td:nth-child(5) spam', 'text'],
    ];

    $range = 'table tbody tr';
    $rt = QueryList::html($html)->rules($rules)
        ->range($range)->query()->getData();

    $today_orders = [];
    $all_income = 0;
    foreach ($rt as $item) {
        if (! $time = strtotime($item['pay_time'])) {
            continue;
        }
        if (date('m-d', $time) !== date('m-d', strtotime('-1 day'))) {
            continue;
        }

        $income = str_replace(['(', ')'], '', $item['income']);
        $today_orders[] = [
            'app' => $item['app'],
            'user' => $item['user'],
            'income' => str_replace(['(', ')'], '', $item['income']),
            'pay_time' => $item['pay_time']
        ];
        $all_income += floatval($income);
    }

    $title = date('m月d日', strtotime('-1 day')).'的Z-Blog应用中心销售';
    $content = '今日的订单共 '. count($today_orders) . ' 个，总收入 ' . $all_income . ' 元。'."\n";
    foreach (array_reverse($today_orders) as $key => $order) {
        $content .= '第' . ($key+1) . '个 - 应用：' . $order['app'] . ' 用户：' . $order['user'] . ' 收入：' . $order['income'] . ' 支付时间：' . $order['pay_time'] . "；\n";
    }

    return sc_send($title, $content);
}

function sc_send($text, $desp = '')
{
    $key = getenv('SCKEY');

	$postdata = http_build_query(
        array(
            'text' => $text,
            'desp' => $desp
        )
    );

    $opts = array('http' =>
        array(
            'method'  => 'POST',
            'header'  => 'Content-type: application/x-www-form-urlencoded',
            'content' => $postdata
        )
    );
    $context  = stream_context_create($opts);
    $result = file_get_contents('https://sc.ftqq.com/'.$key.'.send', false, $context);
    
    print_r('Notice data: '.$result."\n");

    return $result;
}
